/* Logging debug=0 -> Alleen fatals 
 *         debug=1 -> fatals + warnings
 *         debug=2 -> fatals + warnings + info
 *         debug=3 -> fatals + warnings + info + debug
*/
#ifdef SYSLOG
#include<syslog.h>
#endif
extern pid_t getpid();
extern char *logname;
extern char *function;
extern int debug;

#include <sys/times.h>

#define BUFSIZE      1024

#if !defined FACILITY
#define FACILITY LOG_LOCAL0
#endif
#if !defined PRIORITY
#define PRIORITY LOG_NOTICE
#endif

#ifdef SYSLOG
#define LLINF(t,f...) {openlog(logname,getpid(),FACILITY);syslog(LOG_CRIT,f);closelog();}
#define LLINW(t,f...) {if ( debug > 0  ){ openlog(logname,getpid(),FACILITY);syslog(LOG_WARNING,f);closelog();};}
#define LLINI(t,f...) {if ( debug > 1  ){ openlog(logname,getpid(),FACILITY);syslog(LOG_INFO,f);closelog();};}
#define LLIND(t,f...) {if ( debug > 2  ){ openlog(logname,getpid(),FACILITY);syslog(LOG_DEBUG,f);closelog();};}
#else
#define LLINF(t,f...) {fprintf(stderr,"%s - %s (%i): %s: ",logname,function,getpid(),t); fprintf(stderr,f);}
#define LLINW(t,f...) {if ( debug > 0  ){ fprintf(stderr,"%s (%i): %s: \n",logname,getpid(),t); fprintf(stderr,f);};}
#define LLINI(t,f...) {if ( debug > 1 ){ fprintf(stderr,"%s (%i): %s: \n",logname,getpid(),t); fprintf(stderr,f);};}
#define LLIND(t,f...) {if ( debug > 2 ){ fprintf(stderr,"%s - %s (%i): %s: \n",logname,__PRETTY_FUNCTION__,getpid(),t); fprintf(stderr,f);};}
#endif

#define LFATAL(f...)  {LLINF("fatal",f);}
#define LINFO(f...)   {LLINI("info",f);}
#define LWARNING(f...){LLINW("warning",f);}
#ifdef DEBUG
#define LDEBUG(f...)  {LLIND("debug",f);}
#define FUNC {logname=(char *)__FILE__; function=(char *)__PRETTY_FUNCTION__;if ( debug > 4 ) tstamp();};
#define EFUNC {logname=(char *)__FILE__; function=(char *)__PRETTY_FUNCTION__;if ( debug > 4 ) estamp();};
#else
#define FUNC {};
#define EFUNC {};
#define LDEBUG(f...) {};
#endif
